package drawingDemo;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import static java.lang.Math.*;

public class DrawingBox2D extends javax.swing.JPanel
implements MouseListener, MouseMotionListener
{

    private ITrigWave trigFunction = new WaveSine();
    //private ITrigWave trigFunction = new WaveCoine();
    //private ITrigWave trigFunction = new WaveTangent();
    //private ITrigWave trigFunction = new WaveCotangent();
    private FrameDemo2D mWindow;
    private Color backgroundColor;

    /**
     * Creates new form DrawingBox2D
     */
    public DrawingBox2D() {
        initComponents();
        addMouseMotionListener( this );
        addMouseListener( this );
    }

    // MouseListener implementation
    @Override
    public void mousePressed(MouseEvent evt) {
        backgroundColor = getBackground();
        setBackground( Color.GREEN );
        repaint();
    }

    @Override
    public void mouseReleased(MouseEvent evt) {
        setBackground( backgroundColor );
        repaint();
    }

    @Override
    public void mouseEntered(MouseEvent evt) {
    }

    @Override
    public void mouseExited(MouseEvent evt) {
    }

    @Override
    public void mouseClicked(MouseEvent evt) {
        // the mouse coordinates are
        // evt.getX()
        // evt.getY()
    }
    
    // MouseMotionListener implementation
    @Override
    public void mouseMoved(MouseEvent evt)
    {
        // the mouse coordinates are
        // evt.getX()
        // evt.getY()
    }

    @Override
    public void mouseDragged(MouseEvent e)
    {
    }    
    // operations
    // set window reference
    public void setWindow( FrameDemo2D window )
    {
        mWindow = window;
    }
    
    public void update() {
        //before// degrees = (++degrees % 360 == 0) ? 0 : degrees;
        //after//
        trigFunction.calculateNextSegment(1);
    }

    @Override
    public void paintComponent(Graphics graph) {
        super.paintComponent(graph);

        // Our own 2D rendering starts here:
        graph.setColor(Color.RED);
        graph.fillRect(10, 20, 20, 40);
        graph.setColor(Color.BLUE);
        graph.drawString( "degrees=" + trigFunction.getDegrees(), 35, 45);
        //graph.drawLine(100, 100, 80, 80);

        // draw x axis
        graph.setColor(Color.GREEN);
        graph.drawLine(0, 100, 1000, 100);

        // draw trigonometric function
        graph.setColor(Color.BLUE);
        
        //after//
        int x = trigFunction.getNewX();
        int y = trigFunction.getNewY();
        int oldx = trigFunction.getOldX();
        int oldy = trigFunction.getOldY();
        
        while ( x != -1 ) {
            graph.drawLine(oldx, oldy, x, y);
            x = trigFunction.getNewX();
            y = trigFunction.getNewY();
            oldx = trigFunction.getOldX();
            oldy = trigFunction.getOldY();
        }
    }//paintComponent

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
